\environment entorn

<%
require_relative 'biblioteca'

%>


\starttext

\startsubject[title={Paràmetres de dispersió}]

\startsubsubject[title={Preguntes}]

<%
exercicis = Hash.new
%>


<%# Exercici 1 %>
<%
exercicis[1] = Array.new()
# Ha de ser múltiple de 10
for i in (1...21)  
  exercicis[1].push(45 + rand(1..10))
end
%>

\startexercici[reference=exercici-1] S'ha enregistrat durant <%=exercicis[1].size%> dies el temps que tarda un corredor a fer $10 \unit{kilo meter}$. Les marques són les següents arrodonides als minuts.

\startplacetable[location=force, reference=taula:exercicis-automatics-estadistica-1, title={Temps d'un corredor en una carrera de $10 \unit{kilo meter}$ (en minuts)}]
\bTABLE[frame=off,align={flushleft,lohi},width=fit, offset=2mm]
 <% exercicis[1].each_with_index do |p, i| %>
   <% if (i % 10) == 0%>
      \bTR
   <% end %>
   
      \bTD
         <% if i == (exercicis[1].size - 1) %>
           <%=p%>.
         <% else %>
           <%=p%>,
         <% end %>
      \eTD
   
   <% if (i % 10) == 0%>
      \eTR
   <% end %>
 <% end %>
\eTABLE
\stopplacetable

Amb aquestes dades:
\startitemize[a]
\item Quina mitjana té?
\item Aquest corredor és regular? Per què?
\item En quin tant per cent podem dir que es desvia de la mitjana?
\stopitemize

\stopexercici


<%# Exercici 2 %>
<%
exercicis[2] = Hash.new

exercicis[2][0] = Array.new()
# Ha de ser múltiple de 10
for i in (1...21)  
  exercicis[2][0].push(46 + rand(2..4))
end

exercicis[2][1] = Array.new()
# Ha de ser múltiple de 10
for i in (1...21)  
  exercicis[2][1].push(44 + rand(1..4) + rand(1..4))
end


%>

\startexercici[reference=exercici-2] S'ha enregistrat el temps que dos atletes $A$ i $B$ han tardat a recórrer $400 \unit{meter}$ llisos. Les marques són les següents arrodonides als segons (vegeu taules~\in[taula:exercicis-automatics-estadistica-2a] i \in[taula:exercicis-automatics-estadistica-2b]).

\startplacetable[location=force, reference=taula:exercicis-automatics-estadistica-2a, title={Temps del corredor $A$ en una carrera de $400 \unit{meter}$ (en segons)}]
\bTABLE[frame=off,align={flushleft,lohi},width=fit, offset=2mm]
 <% exercicis[2][0].each_with_index do |p, i| %>
   <% if (i % 10) == 0%>
      \bTR
   <% end %>
   
      \bTD
         <% if i == (exercicis[2][0].size - 1) %>
           <%=p%>.
         <% else %>
           <%=p%>,
         <% end %>
      \eTD
   
   <% if (i % 10) == 0%>
      \eTR
   <% end %>
 <% end %>
\eTABLE
\stopplacetable

\startplacetable[location=force, reference=taula:exercicis-automatics-estadistica-2b, title={Temps del corredor $B$ en una carrera de $400 \unit{meter}$ (en segons)}]
\bTABLE[frame=off,align={flushleft,lohi},width=fit, offset=2mm]
 <% exercicis[2][1].each_with_index do |p, i| %>
   <% if (i % 10) == 0%>
      \bTR
   <% end %>
   
      \bTD
         <% if i == (exercicis[2][1].size - 1) %>
           <%=p%>.
         <% else %>
           <%=p%>,
         <% end %>
      \eTD
   
   <% if (i % 10) == 0%>
      \eTR
   <% end %>
 <% end %>
\eTABLE
\stopplacetable

Amb aquestes dades:
\startitemize[a]
\item Quin d'aquests atletes fa millor temps per marca?
\item Digueu quin d'aquests atletes és més regular.
\stopitemize

\stopexercici

\stopsubsubject


<%# ----------------------- Resolució ------------------------ %>
\page[yes]
\startsubsubject[title={Resolució}]

\startitemize
\sym{\in[exercici-1]}

	\startitemize[a]
	
	<%
	mitjana = Estadistica.mitjana(exercicis[1])
	%>

	\item La mitjana és <%=mitjana%> \unit{minute}.
	\item Per saber si és regular o no, podríem calcular la seva desviació mitjana.
	
	Els valors originals menys la seva mitjana amb valor absolut són els següents (taula~\in[taula:exercicis-automatics-estadistica-resolucio-1]).

	\startplacetable[location=force, reference=taula:exercicis-automatics-estadistica-resolucio-1, title={Càlcul de la desviació mitjana}]
	\bTABLE[frame=off,align={flushleft,lohi},width=fit, offset=2mm]
	 <% exercicis[1].each_with_index do |p, i| %>
	   <% if (i % 10) == 0%>
	      \bTR
	   <% end %>
	   
	      \bTD
		 <% if i == (exercicis[1].size - 1) %>
		   <%=(p-mitjana).abs.round(2)%>.
		 <% else %>
		   <%=(p-mitjana).abs.round(2)%>,
		 <% end %>
	      \eTD
	   
	   <% if (i % 10) == 0%>
	      \eTR
	   <% end %>
	 <% end %>
	\eTABLE
	\stopplacetable
        
	<%
	auxiliar = Array.new()
	# Ha de ser múltiple de 10
	exercicis[1].each_with_index do |p, i|
	  v = (p - mitjana).abs
	  auxiliar.push(v)
	end
	
	desviaciom = Estadistica.mitjana(auxiliar)
	%>

        Per tant, la seva desviació mitjana és <%=desviaciom%> \unit{minute}. Això vol dir que, en mitjana, l'atleta es desvia <%=desviaciom%> minuts respecte la seva mitjana. És a dir, en mitjana les seves marques estan entre $<%= (mitjana - desviaciom).round(2) %>$ i $<%= (mitjana + desviaciom).round(2) %>$\footnote{Això no vol dir que tots els valors estiguin dins aquest interval. De fet no podem garantir quin tant per cent de les dades estan dins l'interval. Aquest fet es pot quantificar amb la desviació típica.}
        
        \item Dividirem la desviació mitjana entre la mitjana i la multiplicarem entre 100: en mitjana sabem que la desviació mitjana suposa un $<%=desviaciom%>/<%=mitjana%> \cdot 100 = <%=((desviaciom/mitjana.to_f)*100).round(2)%>$ \%. Si és prou baix o no depèn del context i és totalment interpretable.


	\stopitemize

\sym{\in[exercici-2]}

	\startitemize[a]
	\item Per comparar-los. hem de comparar les mitjanes: la mitjana de $A$ és <%=Estadistica.mitjana(exercicis[2][0])%> i de $B$, <%=Estadistica.mitjana(exercicis[2][1])%>. El que té una mitjana més baixa és el que fa millor temps per marca.

	\item Les desviacions mitjanes dels atletes $A$ i $B$ són, respectivament, <%=Estadistica.desviacio_mitjana(exercicis[2][0])%> i <%=Estadistica.desviacio_mitjana(exercicis[2][1])%>. El que té una desviació mitjana menor és el més regular.

	\stopitemize

\stopitemize 

\vfill
La resolució d'aquests exercicis s'ha calculat automàticament usant programari lliure: encara que totes les expressions són correctes, potser algunes es poden simplificar més.

\stopsubsubject

\stopsubject
\stoptext
